/***************************************************************************
 *   Copyright (C) 2005 by Vlad Svetlichny                                 *
 *   vladsv@inbox.ru                                                       *
 *   Distributed under GPL                                                 *
 ***************************************************************************/

#ifndef KNIGA_H
#define KNIGA_H

#include <qmainwindow.h>

class QTabWidget;
class sidebar;
class QAction;
class QTimer;
class QPopupMenu;
class BookmarkEntry;
class Settings;

class Kniga: public QMainWindow
{
    Q_OBJECT

public:
    Kniga();
    ~Kniga();
    QTabWidget *tw;
    QMap<QString,BookmarkEntry> *bm;
    Settings *settings;
    QPopupMenu *sbMenu;
    QAction *sbShowAct;
    bool sbVisible;
    void changeBookmarksMenu();

protected:
    void closeEvent( QCloseEvent* ); 
    void dragEnterEvent(QDragEnterEvent *event); 
    void dropEvent(QDropEvent *event);
    void changeRecentMenu();
    
public slots:
    void load( QString FileName, int position=0, QString enc=QString::null);
    
private slots:
    void choose();
    void print();
    void closeTab();
    void changedTab();
    void nextTab();
    void prevTab();
    void closeAll();
    void preferences();
    void zoomIn();
    void zoomOut();
    void autoScroll(bool f);
    void setEnc();
    void findClicked();

    void about();
    void aboutQt();

    void recfiles(int i);
    void bookmarksClick(int i);
    void bookmarksDelClick(int i);
    void bookmarksResetClick(int i);
    void bookmarksRenameClick(int i);
    void addBookmark();
    void fullScreen(bool f);
    void sbShow(bool f);
    void sbStatistics();
    void sbBookmarks();
    
    void showReadme();
    void showChangeLog();
    void showAuthors();
    void showCopying();
    void showToDo();
    void sayText();
    
    void scrolling();

private:
    QTimer* scrollTimer;
    QPrinter *printer;
    QString fn;
    int rec[5];
    QString strippedName(QString fullFileName);
    QPopupMenu* createRecentMenu();
    void createBookmarksMenu();
    QPopupMenu *recent, *bookmenu, *bookdelmenu, *bookresetmenu, *bookrenamemenu;
    sidebar *sb;
    QAction *fileOpenAct, *filePrintAct, *filePrefAct, *fileQuitAct, *viewFullAct, *viewZoomInAct, *viewZoomOutAct, *viewAutoScrollAct, *viewSetEncAct, *searchFindAct, *tabNextAct, *tabPrevAct, *tabCloseCurrentAct, *tabCloseAllAct, *sbBookmarksAct, *sbStatsAct, *bmAddAct, *tulzSpeakAct, *helpAboutAct, *helpAboutQtAct, *helpWhatsThisAct, *helpReadmeAct, *helpAuthorsAct, *helpChangeLogAct, *helpCopyingAct, *helpToDoAct;
};


#endif
