/***************************************************************************
 *   Copyright (C) 2005 by Vlad Svetlichny                                 *
 *   vladsv@inbox.ru                                                       *
 *   Distributed under GPL                                                 *
 ***************************************************************************/
#ifndef SETTINGS_H
#define SETTINGS_H

/**
@author Vlad Svetlichny
*/

#include <qfont.h>
#include <qcolor.h>
#include <qmap.h>

class QFont;
class QColor;

class BookmarkEntry{
public:
    BookmarkEntry(){};
    BookmarkEntry(QString ffile,int fposition, QString fenc)
     {file=ffile;position=fposition;enc=fenc;}
    QString file,enc;
    int position;
};

class Settings
{
public:
    QFont  font;
    QColor background;
    QColor foreground;
    QString defaultCode;
    bool autoCodeRus, autoCodeUa, autoCodeGerman, autoCodePolish,
    autoCodeSerbian, autoCodeFinnish, autoCodePortuguese, autoCodeSlovak,
    autoCodeSlovenian, autoCodeTurkish, autoCodeSpanish, autoCodeLatvian;
    bool usePaper;
    QString recentFiles[5];
    QString paper;
    QMap<QString, BookmarkEntry> bm;
    bool confirmOnExit, confirmOnBmDel, confirmOnCloseAll;
    int winHeight, winWidth, sbCurrent, scroll, sbWidth;
    bool fullscreen, sbVisible, autoscroll;
    void loadSettings();
    void saveSettings();
};

#endif
