 /**************************************************************************
 *   Copyright (C) 2005 by Vlad Svetlichny                                 *
 *   vladsv@inbox.ru                                                       *
 *   Distributed under GPL                                                 *
 ***************************************************************************/
 #include "sidebar.h"
 #include "bookmarksb.h"
 #include "kniga.h"
 #include "statisticsb.h"

 #include <qpushbutton.h>
 #include <qlabel.h>
 #include <qpixmap.h>
 #include <qaction.h>

sidebar::sidebar(QWidget *parent, Kniga* kkniga)
 : QWidget(parent)
{
    initOne=FALSE;
    fkniga=kkniga;
    
    QPushButton *closeBtn=new QPushButton(this);
    closeBtn->setPixmap(QPixmap::fromMimeSource("sbclose.png"));
    closeBtn->setFlat(TRUE);
    select=new QComboBox(this);
    
    select->insertItem(tr("Bookmarks"));
    select->insertItem(tr("Statistics"));
//     select->insertItem(tr("View"));
//     select->insertItem(tr("Search"));
//     select->insertItem(tr("History"));
    
    bookmarksb=new BookmarkSB(this,fkniga);
    bookmarksb->hide();
    statisticsb=new StatisticSB(this,fkniga);
    statisticsb->hide();
    
    vbox=new QVBoxLayout(this,5,5);
    QHBoxLayout *hbox=new QHBoxLayout(vbox,5);
    hbox->addWidget(new QLabel(tr("<b>Sidebar</b>"),this),7);
    hbox->addWidget(closeBtn,1,Qt::AlignRight);
    vbox->addWidget(select,1);
    vbox->addWidget(bookmarksb,10);
    vbox->addWidget(statisticsb,10);
   // vbox->addWidget(frame,50);
    
    connect(closeBtn,SIGNAL(clicked()), SLOT(setHide()));
    connect(select,SIGNAL(activated (int)),
                   SLOT  (changeBar (int)));
    changeBar(0);
}

void sidebar::changeBar(int index)
{
    currentIndex=index;
    QWidget *widget;
    switch (index)
    {
      case 0:
          widget=bookmarksb;
          break;
          
      case 1:
          widget=statisticsb;
    }
    if (initOne) {current->hide();}
    else initOne=TRUE;
    current=widget;
    current->show();

}

void sidebar::setHide()
{
    hide();
    ((QAction *)(fkniga->sbShowAct))->setOn(FALSE);
    fkniga->sbVisible=FALSE;
}

void sidebar::setCurrent(int i)
{
    select->setCurrentItem(i);
}
